/* GCC */

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

void read(vector<int>& x, int& k)
{
    scanf("%d", &k);

    for (int i=0;i<k;++i) {
        int t;
        scanf("%d", &t);
        x.push_back(t);
    }
}

int main()
{
    freopen("subseq.in", "r", stdin);
    freopen("subseq.out", "w", stdout);

    int k, l;
    vector<int> x, y;

    read(x, k);
    read(y, l);

    vector<int> dp[2];

    dp[0].resize(max(k,l)+1);
    dp[1].resize(max(k,l)+1);


    for (int i = 1; i <= k; ++i) {

        for (int j = 1; j <= l; ++j) {
            if (x[i-1] == y[j-1]) {
                dp[1][j] = dp[0][j-1]+1;
            } else {
                dp[1][j] = max(dp[0][j], dp[1][j-1]);
            }
        }
        dp[1].swap(dp[0]);
    }

    printf("%d\n", dp[0][l]);

    return 0;
}
