/* GCC */
#include <fstream>
#include <vector>

using namespace std;

int main(void)
{
	ios_base::sync_with_stdio(false);
	int k, l, a[16000], b[16000];
	ifstream in("subseq.in");
	in >> k;
	for(int i = 0; i < k; ++i)
        in >> a[i];
    in >> l;
    for(int i = 0; i < l; ++i)
        in >> b[i];
	in.close();
    vector<int> pr(l, 0), cur(l);
    for(int i = 0; i < k; ++i)
    {
        cur[0] = (a[i] == b[0] ? 1 : pr[0]);
        for(int j = 1; j < l; ++j)
            cur[j] = (a[i] == b[j] ? pr[j-1] + 1 : max(cur[j - 1], pr[j]));
        pr.swap(cur);
    }
	ofstream out("subseq.out");
	out << pr[l - 1] << '\n';
	out.close();
	return 0;
}
