/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

vector <int> v[2], s[2];
int n1, n2, s1, s2, i, j, l0, l1;

int main()
{
    freopen("subseq.in", "r", stdin);
    freopen("subseq.out", "w", stdout);

    scanf("%d", &n1);
    s[0].resize(n1 + 1);
    for(i = 1; i <= n1; i++)
        scanf("%d", &s[0][i]);

    scanf("%d", &n2);
    s[1].resize(n2 + 1);
    for(i = 1; i <= n2; i++)
        scanf("%d", &s[1][i]);

    s1 = 0;
    s2 = 1;

    if(n1 < n2)
    {
        swap(n1, n2);
        swap(s1, s2);
    }

    l0 = 0;
    l1 = 1;
    v[0].resize(n2 + 1, 0);
    v[1].resize(n2 + 1, 0);
    for(i = 1; i <= n1; i++)
    {
        for(j = 1; j <= n2; j++)
            if(s[s1][i] == s[s2][j])
                v[l1][j] = v[l0][j - 1] + 1;
            else
                v[l1][j] = max(v[l1][j - 1], v[l0][j]);

        l0 = 1 - l0;
        l1 = 1 - l1;
    }

    printf("%d\n", v[l0][n2]);

    return 0;
}










