#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>

using namespace std;
ifstream fin("family.in");
ofstream fout("family.out");
vector< vector<string> > relations(30, vector<string>(30, ""));
vector<string> people;
vector<bool> male(30);
int n=0;

void show(vector<string> a){
    for(int i=0; i<a.size(); i++){
        cout<<a[i]<<' ';
    }
    cout<<endl;
}

int getNumOfName(string a){
    for(int i=0; i<n; i++){
        if(people[i]==a) return i;
    }
    n++;
    people.push_back(a);
    return n-1;
}

string getName(string a){
    if(a=="") return "";
    int last=a.size()-1;
    if(a[last]==''){
        a[last]='';
        male[getNumOfName(a)]=false;
        return a;
    }
    if(a[last]==''){
        a[last]='';
        return a;
    }
    if(a[last]==''){
        a=a.substr(0, last);
        return a;
    }
    if(a[last]==''){
        a[last]='';
        return a;
    }
}
string getSecondName(string a){
    if(a=="") return "";
    int last=a.size()-1;
    if(a[last]==''){
        a[last]='';
        return a;
    }
    if(a[last]==''){
        a[last]='';
        return a;
    }
    if(a[last]==''){
        a[last]='';
        return a;
    }

    a=a+'';
    return a;

}

void setOthers(int name1, string rel, int name2){
    int i, z;
        if(rel==""){
            for(z=0; z<n; z++){
                if(z==name2) continue;
                if(relations[z][name2]==""){
                    relations[name2][z]="";
                    relations[name1][z]="";
                    relations[z][name1]=="";
                }
                if(relations[z][name2]==""){
                    relations[name2][z]="";
                    relations[name1][z]="";
                    relations[z][name1]=="";
                }
                if(relations[z][name1]==""){
                    relations[name2][z]="";
                    relations[name1][z]="";
                    relations[z][name2]=="";
                }
                if(relations[z][name1]==""){
                    relations[name2][z]="";
                    relations[name1][z]="";
                    relations[z][name2]=="";
                }
            }
        }

        if(rel==""){
            for(z=0; z<n; z++){
                if(z==name2) continue;
                if(relations[z][name2]==""){
                    relations[name1][z]="";
                    relations[z][name1]=="";
                }
                if(relations[z][name2]==""){
                    relations[name1][z]="";
                    relations[z][name1]=="";
                }
                if(relations[z][name1]==""){
                    relations[name2][z]="";
                    relations[z][name2]=="";
                }
                if(relations[z][name1]==""){
                    relations[name2][z]="";
                    relations[z][name2]=="";
                }
            }
        }
        if(rel==""){
            for(z=0; z<n; z++){
                if(z==name2) continue;
                if(relations[z][name2]==""){
                    relations[name1][z]="";
                    relations[z][name1]=="";
                }
                if(relations[z][name2]==""){
                    relations[name1][z]="";
                    relations[z][name1]=="";
                }
                if(relations[z][name1]==""){
                    relations[name2][z]="";
                    relations[z][name2]=="";
                }
                if(relations[z][name1]==""){
                    relations[name2][z]="";
                    relations[z][name2]=="";
                }
            }
        }
    for(i=0; i<n; i++){
        if(i==name1) continue;
        //make children
        //make parents
        if(rel=="" || rel==""){
            if(male[name2]) relations[name2][name1]="";
                else relations[name2][name1]="";
        }
        //make siblings
        if(relations[name1][i]=="" && (relations[i][name2]=="" || relations[i][name2]=="")){
            relations[name1][name2]="";
            if(male[name2]) relations[name2][name1]="";
            else relations[name2][name1]="";
        }
        if(relations[name1][i]=="" && (relations[i][name2]=="" || relations[i][name2]=="")){
            relations[name1][name2]="";
            if(male[name2]) relations[name2][name1]="";
            else relations[name2][name1]="";
        }
    }
}

int main(){
    int i, z;

    string person, goal;
    getline(fin, person);
    getline(fin, goal);

    string curr, currName, currRelated, currGoal;
    while(!fin.eof()){
        getline(fin, curr);
        if(curr=="") break;
        //NAME
        for(i=0; curr[i]!=' '; i++);
        currName=curr.substr(0, i);
        int currNum=getNumOfName(currName);
        i+=3;
        //RELATED
        for(z=i; curr[z]!=' '; z++);
        currRelated=curr.substr(i, z-i);
        z++;
        //GOAL
        currGoal=curr.substr(z, curr.length()-z);
        currGoal=getName(currGoal);

        int goalNum=getNumOfName(currGoal);

        if(currRelated==""){
            male[currNum]=true;
            relations[currNum][goalNum]="";
        }
        if(currRelated==""){
            male[currNum]=false;
            relations[currNum][goalNum]="";
        }
        if(currRelated==""){
            male[currNum]=false;
            male[goalNum]=true;
            relations[currNum][goalNum]="";
            relations[goalNum][currNum]="";
        }
        //setOthers(currNum, currRelated, goalNum);
    }

    int personNum=getNumOfName(person);
    int secondNum=getNumOfName(goal);

    if(relations[personNum][secondNum]==""){
        if(male[personNum]) relations[personNum][secondNum]="";
            else relations[personNum][secondNum]="";
    }

    fout<<person<<" - "<<relations[personNum][secondNum]<<' '<<getSecondName(goal)<<endl;

    fin.close();
    fout.close();
    return 0;
}
