#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

void show(vector<int> a){
    for(int i=0; i<a.size(); i++){
        cout<<a[i]<<' ';
    }
    cout<<endl;
}

int main(){
    ifstream fin("subseq.in");
    ofstream fout("subseq.out");

    //File in
    int k, l, i, z;
    fin>>k;
    vector<int> kseq(k+1);
    for(i=1; i<=k; i++){
        fin>>kseq[i];
    }
    fin>>l;
    vector<int> lseq(l+1);
    for(i=1; i<=l; i++){
        fin>>lseq[i];
    }
    /*if(l>k){
        swap(l, k);
        swap(lseq, kseq);
    }*/


    //Filling matrix
    vector< vector<int> > matrix(2, vector<int>(k+1, 0));
    int curr=1, prev=0;
    for(i=1; i<=l; i++){
        for(z=1; z<=k; z++){
            if (lseq[i]==kseq[z]){
                matrix[curr][z]=matrix[prev][z-1]+1;
            } else {
                matrix[curr][z]=max(matrix[prev][z], matrix[curr][z-1]);
            }
        }
        swap(curr, prev);
    }

    fout<<matrix[prev][k]<<endl;


    fin.close();
    fout.close();
    return 0;
}
